# std::deque< _Tp, _Alloc > Class Template Reference
[Sequences]

A standard container using fixed-size memory allocation and constant-time manipulation of elements at either end. More...

Inheritance diagram for std::deque< _Tp, _Alloc >:
[legend]

List of all members.

## Public Types

- typedef _Alloc allocator_type
- typedef _Base::const_iterator const_iterator
- typedef
  _Tp_alloc_type::const_pointer const_pointer
- typedef
  _Tp_alloc_type::const_reference const_reference
- typedef std::reverse_iterator
  < const_iterator > const_reverse_iterator
- typedef ptrdiff_t difference_type
- typedef _Base::iterator iterator
- typedef _Tp_alloc_type::pointer pointer
- typedef _Tp_alloc_type::reference reference
- typedef std::reverse_iterator
  < iterator > reverse_iterator
- typedef size_t size_type
- typedef _Tp value_type

## Public Member Functions

- deque ()
- deque (const allocator_type &__a)
- deque (const deque &__x)
- deque (deque &&__x)
- deque (size_type __n, const value_type &__value=value_type(), const allocator_type &__a=allocator_type())
- deque (initializer_list< value_type > __l, const allocator_type &__a=allocator_type())
- template<typename _InputIterator > deque (_InputIterator __first, _InputIterator __last, const allocator_type &__a=allocator_type())
- ~deque ()
- void assign (size_type __n, const value_type &__val)
- template<typename _InputIterator > void assign (_InputIterator __first, _InputIterator __last)
- void assign (initializer_list< value_type > __l)
- reference at (size_type __n)
- const_reference at (size_type __n) const
- reference back ()
- const_reference back () const
- iterator begin ()
- const_iterator begin () const
- const_iterator cbegin () const
- const_iterator cend () const
- void clear ()
- const_reverse_iterator crbegin () const
- const_reverse_iterator crend () const
- template<typename... _Args> iterator emplace (iterator __position, _Args &&...__args)
- template<typename... _Args> void emplace_back (_Args &&...__args)
- template<typename... _Args> void emplace_front (_Args &&...__args)
- bool empty () const
- iterator end ()
- const_iterator end () const
- iterator erase (iterator __position)
- iterator erase (iterator __first, iterator __last)
- reference front ()
- const_reference front () const
- allocator_type get_allocator () const
- template<typename _InputIterator > void insert (iterator __position, _InputIterator __first, _InputIterator __last)
- void insert (iterator __p, initializer_list< value_type > __l)
- iterator insert (iterator __position, value_type &&__x)
- void insert (iterator __position, size_type __n, const value_type &__x)
- iterator insert (iterator __position, const value_type &__x)
- size_type max_size () const
- deque & operator= (const deque &__x)
- deque & operator= (deque &&__x)
- deque & operator= (initializer_list< value_type > __l)
- reference operator[] (size_type __n)
- const_reference operator[] (size_type __n) const
- void pop_back ()
- void pop_front ()
- void push_back (value_type &&__x)
- void push_back (const value_type &__x)
- void push_front (value_type &&__x)
- void push_front (const value_type &__x)
- reverse_iterator rbegin ()
- const_reverse_iterator rbegin () const
- reverse_iterator rend ()
- const_reverse_iterator rend () const
- void resize (size_type __new_size, value_type __x=value_type())
- void shrink_to_fit ()
- size_type size () const
- void swap (deque &__x)

## Protected Types

- enum { _S_initial_map_size }
- typedef _Alloc::template
  rebind< _Tp * >::other _Map_alloc_type
- typedef pointer * _Map_pointer

## Protected Member Functions

- _Tp ** _M_allocate_map (size_t __n)
- _Tp * _M_allocate_node ()
- template<typename _ForwardIterator > void _M_assign_aux (_ForwardIterator __first, _ForwardIterator __last, std::forward_iterator_tag)
- template<typename _InputIterator > void _M_assign_aux (_InputIterator __first, _InputIterator __last, std::input_iterator_tag)
- template<typename _Integer > void _M_assign_dispatch (_Integer __n, _Integer __val, __true_type)
- template<typename _InputIterator > void _M_assign_dispatch (_InputIterator __first, _InputIterator __last, __false_type)
- void _M_create_nodes (_Tp **__nstart, _Tp **__nfinish)
- void _M_deallocate_map (_Tp **__p, size_t __n)
- void _M_deallocate_node (_Tp *__p)
- template<typename _Alloc1 > void _M_destroy_data (iterator __first, iterator __last, const _Alloc1 &)
- void _M_destroy_data (iterator __first, iterator __last, const std::allocator< _Tp > &)
- void _M_destroy_data_aux (iterator __first, iterator __last)
- void _M_destroy_nodes (_Tp **__nstart, _Tp **__nfinish)
- void _M_erase_at_begin (iterator __pos)
- void _M_erase_at_end (iterator __pos)
- void _M_fill_assign (size_type __n, const value_type &__val)
- void _M_fill_initialize (const value_type &__value)
- void _M_fill_insert (iterator __pos, size_type __n, const value_type &__x)
- _Map_alloc_type _M_get_map_allocator () const
- _Tp_alloc_type & _M_get_Tp_allocator ()
- const _Tp_alloc_type & _M_get_Tp_allocator () const
- template<typename _Integer > void _M_initialize_dispatch (_Integer __n, _Integer __x, __true_type)
- template<typename _InputIterator > void _M_initialize_dispatch (_InputIterator __first, _InputIterator __last, __false_type)
- void _M_initialize_map (size_t)
- void _M_insert_aux (iterator __pos, size_type __n, const value_type &__x)
- template<typename _ForwardIterator > void _M_insert_aux (iterator __pos, _ForwardIterator __first, _ForwardIterator __last, size_type __n)
- template<typename... _Args> iterator _M_insert_aux (iterator __pos, _Args &&...__args)
- template<typename _Integer > void _M_insert_dispatch (iterator __pos, _Integer __n, _Integer __x, __true_type)
- template<typename _InputIterator > void _M_insert_dispatch (iterator __pos, _InputIterator __first, _InputIterator __last, __false_type)
- void _M_range_check (size_type __n) const
- template<typename _InputIterator > void _M_range_insert_aux (iterator __pos, _InputIterator __first, _InputIterator __last, std::input_iterator_tag)
- template<typename _ForwardIterator > void _M_range_insert_aux (iterator __pos, _ForwardIterator __first, _ForwardIterator __last, std::forward_iterator_tag)

- template<typename _InputIterator > void _M_range_initialize (_InputIterator __first, _InputIterator __last, std::input_iterator_tag)
- template<typename _ForwardIterator > void _M_range_initialize (_ForwardIterator __first, _ForwardIterator __last, std::forward_iterator_tag)

- template<typename... _Args> void _M_push_back_aux (_Args &&...__args)
- template<typename... _Args> void _M_push_front_aux (_Args &&...__args)
- void _M_pop_back_aux ()
- void _M_pop_front_aux ()

- iterator _M_reserve_elements_at_front (size_type __n)
- iterator _M_reserve_elements_at_back (size_type __n)
- void _M_new_elements_at_front (size_type __new_elements)
- void _M_new_elements_at_back (size_type __new_elements)

- void _M_reserve_map_at_back (size_type __nodes_to_add=1)
- void _M_reserve_map_at_front (size_type __nodes_to_add=1)
- void _M_reallocate_map (size_type __nodes_to_add, bool __add_at_front)

## Static Protected Member Functions

- static size_t _S_buffer_size ()

## Protected Attributes

- _Deque_impl _M_impl

## Detailed Description

### template<typename _Tp, typename _Alloc = std::allocator<_Tp>>
class std::deque< _Tp, _Alloc >

A standard container using fixed-size memory allocation and constant-time manipulation of elements at either end.

Meets the requirements of a container, a reversible container, and a sequence, including the optional sequence requirements.

In previous HP/SGI versions of deque, there was an extra template parameter so users could control the node size. This extension turned out to violate the C++ standard (it can be detected using template template parameters), and it was removed.

Here's how a deque<Tp> manages memory. Each deque has 4 members:

- Tp** _M_map
- size_t _M_map_size
- iterator _M_start, _M_finish

map_size is at least 8. map is an array of map_size pointers-to-. (The name map has nothing to do with the std::map class, and nodes should not be confused with std::list's usage of node.)

A node has no specific type name as such, but it is referred to as node in this file. It is a simple array-of-Tp. If Tp is very large, there will be one Tp element per node (i.e., an array of one). For non-huge Tp's, node size is inversely related to Tp size: the larger the Tp, the fewer Tp's will fit in a node. The goal here is to keep the total size of a node relatively small and constant over different Tp's, to improve allocator efficiency.

Not every pointer in the map array will point to a node. If the initial number of elements in the deque is small, the /middle/ map pointers will be valid, and the ones at the edges will be unused. This same situation will arise as the map grows: available map pointers, if any, will be on the ends. As new nodes are created, only a subset of the map's pointers need to be copied outward.

Class invariants:

- For any nonsingular iterator i:
  - i.node points to a member of the map array. (Yes, you read that correctly: i.node does not actually point to a node.) The member of the map array is what actually points to the node.
  - i.first == *(i.node) (This points to the node (first Tp element).)
  - i.last == i.first + node_size
  - i.cur is a pointer in the range [i.first, i.last). NOTE: the implication of this is that i.cur is always a dereferenceable pointer, even if i is a past-the-end iterator.
- Start and Finish are always nonsingular iterators. NOTE: this means that an empty deque must have one node, a deque with <N elements (where N is the node buffer size) must have one node, a deque with N through (2N-1) elements must have two nodes, etc.
- For every node other than start.node and finish.node, every element in the node is an initialized object. If start.node == finish.node, then [start.cur, finish.cur) are initialized objects, and the elements outside that range are uninitialized storage. Otherwise, [start.cur, start.last) and [finish.first, finish.cur) are initialized objects, and [start.first, start.cur) and [finish.cur, finish.last) are uninitialized storage.
- [map, map + map_size) is a valid, non-empty range.
- [start.node, finish.node] is a valid range contained within [map, map + map_size).
- A pointer in the range [map, map + map_size) points to an allocated node if and only if the pointer is in the range [start.node, finish.node].

Here's the magic: nothing in deque is aware of the discontiguous storage!

The memory setup and layout occurs in the parent, _Base, and the iterator class is entirely responsible for leaping from one node to the next. All the implementation routines for deque itself work only through the start and finish iterators. This keeps the routines simple and sane, and we can use other standard algorithms as well.

Definition at line 713 of file stl_deque.h.

## Constructor & Destructor Documentation

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

std::deque< _Tp, _Alloc >::deque | ( |  | ) | `[inline]`

Default constructor creates no elements.

Definition at line 765 of file stl_deque.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

std::deque< _Tp, _Alloc >::deque | ( | const allocator_type & | __a | ) | `[inline, explicit]`

Creates a deque with no elements.

Parameters:

  | a | An allocator object.

Definition at line 773 of file stl_deque.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

std::deque< _Tp, _Alloc >::deque | ( | size_type | __n,
|  | const value_type & | __value = `value_type()`,
|  | const allocator_type & | __a = `allocator_type()` |
| ) |  |  | `[inline, explicit]`

Creates a deque with copies of an exemplar element.

Parameters:

  | n | The number of elements to initially create.
  | value | An element to copy.
  | a | An allocator.

This constructor fills the deque with n copies of value.

Definition at line 785 of file stl_deque.h.

References std::deque< _Tp, _Alloc >::_M_fill_initialize().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

std::deque< _Tp, _Alloc >::deque | ( | const deque< _Tp, _Alloc > & | __x | ) | `[inline]`

Deque copy constructor.

Parameters:

  | x | A deque of identical element and allocator types.

The newly-created deque uses a copy of the allocation object used by x.

Definition at line 797 of file stl_deque.h.

References std::deque< _Tp, _Alloc >::begin(), and std::deque< _Tp, _Alloc >::end().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

std::deque< _Tp, _Alloc >::deque | ( | deque< _Tp, _Alloc > && | __x | ) | `[inline]`

Deque move constructor.

Parameters:

  | x | A deque of identical element and allocator types.

The newly-created deque contains the exact contents of x. The contents of x are a valid, but unspecified deque.

Definition at line 811 of file stl_deque.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

std::deque< _Tp, _Alloc >::deque | ( | initializer_list< value_type > | __l,
|  | const allocator_type & | __a = `allocator_type()` |
| ) |  |  | `[inline]`

Builds a deque from an initializer list.

Parameters:

  | l | An initializer_list.
  | a | An allocator object.

Create a deque consisting of copies of the elements in the initializer_list l.

This will call the element type's copy constructor N times (where N is l.size()) and do no memory reallocation.

Definition at line 825 of file stl_deque.h.

References std::deque< _Tp, _Alloc >::_M_range_initialize().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>
template<typename _InputIterator >

std::deque< _Tp, _Alloc >::deque | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | const allocator_type & | __a = `allocator_type()` |
| ) |  |  | `[inline]`

Builds a deque from a range.

Parameters:

  | first | An input iterator.
  | last | An input iterator.
  | a | An allocator object.

Create a deque consisting of copies of the elements from [first, last).

If the iterators are forward, bidirectional, or random-access, then this will call the elements' copy constructor N times (where N is distance(first,last)) and do no memory reallocation. But if only input iterators are used, then this will do at most 2N calls to the copy constructor, and logN memory reallocations.

Definition at line 850 of file stl_deque.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

std::deque< _Tp, _Alloc >::~deque | ( |  | ) | `[inline]`

The dtor only erases the elements, and note that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 864 of file stl_deque.h.

References std::deque< _Tp, _Alloc >::begin(), and std::deque< _Tp, _Alloc >::end().

## Member Function Documentation

template<typename _Tp , typename _Alloc >

void deque::_M_fill_initialize | ( | const value_type & | __value | ) | `[protected]`

Fills the deque with copies of value.

Parameters:

  | value | Initial value.

Returns:
  Nothing.

Precondition:
  _M_start and _M_finish have already been initialized, but none of the deque's elements have yet been constructed.

This function is called only when the user provides an explicit size (with or without an explicit exemplar value).

Definition at line 277 of file deque.tcc.

References std::_Destroy().

Referenced by std::deque< _Tp, _Alloc >::deque().

template<typename _Tp , typename _Alloc >

void std::_Deque_base< _Tp, _Alloc >::_M_initialize_map | ( | size_t | __num_elements | ) | `[protected, inherited]`

Layout storage.

Parameters:

  | num_elements | The count of T's for which to allocate space at first.

Returns:
  Nothing.

The initial underlying memory layout is a bit complicated...

Definition at line 568 of file stl_deque.h.

References std::max().

Referenced by std::deque< _Tp, _Alloc >::_M_range_initialize().

template<typename _Tp , typename _Alloc >

void deque::_M_new_elements_at_back | ( | size_type | __new_elements | ) | `[protected]`

Memory-handling helpers for the previous internal insert functions.

Definition at line 771 of file deque.tcc.

References std::deque< _Tp, _Alloc >::_M_reserve_map_at_back(), std::deque< _Tp, _Alloc >::max_size(), and std::deque< _Tp, _Alloc >::size().

Referenced by std::deque< _Tp, _Alloc >::_M_reserve_elements_at_back().

template<typename _Tp , typename _Alloc >

void deque::_M_new_elements_at_front | ( | size_type | __new_elements | ) | `[protected]`

Memory-handling helpers for the previous internal insert functions.

Definition at line 746 of file deque.tcc.

References std::deque< _Tp, _Alloc >::_M_reserve_map_at_front(), std::deque< _Tp, _Alloc >::max_size(), and std::deque< _Tp, _Alloc >::size().

Referenced by std::deque< _Tp, _Alloc >::_M_reserve_elements_at_front().

template<typename _Tp , typename _Alloc >

void deque::_M_pop_back_aux | ( |  | ) | `[protected]`

Helper functions for push_* and pop_*.

Definition at line 427 of file deque.tcc.

Referenced by std::deque< _Tp, _Alloc >::pop_back().

template<typename _Tp , typename _Alloc >

void deque::_M_pop_front_aux | ( |  | ) | `[protected]`

Helper functions for push_* and pop_*.

Definition at line 442 of file deque.tcc.

Referenced by std::deque< _Tp, _Alloc >::pop_front().

template<typename _Tp , typename _Alloc >
template<typename... _Args>

void deque::_M_push_back_aux | ( | _Args &&... | __args | ) | `[protected]`

Helper functions for push_* and pop_*.

Definition at line 361 of file deque.tcc.

Referenced by std::deque< _Tp, _Alloc >::push_back().

template<typename _Tp , typename _Alloc >
template<typename... _Args>

void deque::_M_push_front_aux | ( | _Args &&... | __args | ) | `[protected]`

Helper functions for push_* and pop_*.

Definition at line 395 of file deque.tcc.

Referenced by std::deque< _Tp, _Alloc >::push_front().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::deque< _Tp, _Alloc >::_M_range_check | ( | size_type | __n | ) | const`[inline, protected]`

Safety check used only from at().

Definition at line 1159 of file stl_deque.h.

References std::deque< _Tp, _Alloc >::size().

Referenced by std::deque< _Tp, _Alloc >::at().

template<typename _Tp , typename _Alloc >
template<typename _InputIterator >

void deque::_M_range_initialize | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | std::input_iterator_tag |  |
| ) |  |  | `[protected]`

Fills the deque with whatever is in [first,last).

Parameters:

  | first | An input iterator.
  | last | An input iterator.

Returns:
  Nothing.

If the iterators are actually forward iterators (or better), then the memory layout can be done all at once. Else we move forward using push_back on each value from the iterator.

Definition at line 303 of file deque.tcc.

References std::_Deque_base< _Tp, _Alloc >::_M_initialize_map(), std::deque< _Tp, _Alloc >::clear(), and std::deque< _Tp, _Alloc >::push_back().

Referenced by std::deque< _Tp, _Alloc >::deque().

template<typename _Tp , typename _Alloc >
template<typename _ForwardIterator >

void deque::_M_range_initialize | ( | _ForwardIterator | __first,
|  | _ForwardIterator | __last,
|  | std::forward_iterator_tag |  |
| ) |  |  | `[protected]`

Fills the deque with whatever is in [first,last).

Parameters:

  | first | An input iterator.
  | last | An input iterator.

Returns:
  Nothing.

If the iterators are actually forward iterators (or better), then the memory layout can be done all at once. Else we move forward using push_back on each value from the iterator.

Definition at line 323 of file deque.tcc.

References std::_Destroy(), std::_Deque_base< _Tp, _Alloc >::_M_initialize_map(), std::advance(), and std::distance().

template<typename _Tp , typename _Alloc >

void deque::_M_reallocate_map | ( | size_type | __nodes_to_add,
|  | bool | __add_at_front |
| ) |  |  | `[protected]`

Memory-handling helpers for the major map.

Makes sure the _M_map has space for new nodes. Does not actually add the nodes. Can invalidate _M_map pointers. (And consequently, deque iterators.)

Definition at line 796 of file deque.tcc.

References std::max().

Referenced by std::deque< _Tp, _Alloc >::_M_reserve_map_at_back(), and std::deque< _Tp, _Alloc >::_M_reserve_map_at_front().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

iterator std::deque< _Tp, _Alloc >::_M_reserve_elements_at_back | ( | size_type | __n | ) | `[inline, protected]`

Memory-handling helpers for the previous internal insert functions.

Definition at line 1768 of file stl_deque.h.

References std::deque< _Tp, _Alloc >::_M_new_elements_at_back().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

iterator std::deque< _Tp, _Alloc >::_M_reserve_elements_at_front | ( | size_type | __n | ) | `[inline, protected]`

Memory-handling helpers for the previous internal insert functions.

Definition at line 1758 of file stl_deque.h.

References std::deque< _Tp, _Alloc >::_M_new_elements_at_front().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::deque< _Tp, _Alloc >::_M_reserve_map_at_back | ( | size_type | __nodes_to_add = `1` | ) | `[inline, protected]`

Memory-handling helpers for the major map.

Makes sure the _M_map has space for new nodes. Does not actually add the nodes. Can invalidate _M_map pointers. (And consequently, deque iterators.)

Definition at line 1794 of file stl_deque.h.

References std::deque< _Tp, _Alloc >::_M_reallocate_map().

Referenced by std::deque< _Tp, _Alloc >::_M_new_elements_at_back().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::deque< _Tp, _Alloc >::_M_reserve_map_at_front | ( | size_type | __nodes_to_add = `1` | ) | `[inline, protected]`

Memory-handling helpers for the major map.

Makes sure the _M_map has space for new nodes. Does not actually add the nodes. Can invalidate _M_map pointers. (And consequently, deque iterators.)

Definition at line 1802 of file stl_deque.h.

References std::deque< _Tp, _Alloc >::_M_reallocate_map().

Referenced by std::deque< _Tp, _Alloc >::_M_new_elements_at_front().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::deque< _Tp, _Alloc >::assign | ( | size_type | __n,
|  | const value_type & | __val |
| ) |  |  | `[inline]`

Assigns a given value to a deque.

Parameters:

  | n | Number of elements to be assigned.
  | val | Value to be assigned.

This function fills a deque with n copies of the given value. Note that the assignment completely changes the deque and that the resulting deque's size is the same as the number of elements assigned. Old data may be lost.

Definition at line 925 of file stl_deque.h.

Referenced by std::deque< _Tp, _Alloc >::operator=().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>
template<typename _InputIterator >

void std::deque< _Tp, _Alloc >::assign | ( | _InputIterator | __first,
|  | _InputIterator | __last |
| ) |  |  | `[inline]`

Assigns a range to a deque.

Parameters:

  | first | An input iterator.
  | last | An input iterator.

This function fills a deque with copies of the elements in the range [first,last).

Note that the assignment completely changes the deque and that the resulting deque's size is the same as the number of elements assigned. Old data may be lost.

Definition at line 942 of file stl_deque.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::deque< _Tp, _Alloc >::assign | ( | initializer_list< value_type > | __l | ) | `[inline]`

Assigns an initializer list to a deque.

Parameters:

  | l | An initializer_list.

This function fills a deque with copies of the elements in the initializer_list l.

Note that the assignment completely changes the deque and that the resulting deque's size is the same as the number of elements assigned. Old data may be lost.

Definition at line 961 of file stl_deque.h.

References std::deque< _Tp, _Alloc >::assign().

Referenced by std::deque< _Tp, _Alloc >::assign().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

reference std::deque< _Tp, _Alloc >::at | ( | size_type | __n | ) | `[inline]`

Provides access to the data contained in the deque.

Parameters:

  | n | The index of the element for which data should be accessed.

Returns:
  Read/write reference to data.

Exceptions:

  | std::out_of_range | If n is an invalid index.

This function provides for safer data access. The parameter is first checked that it is in the range of the deque. The function throws out_of_range if the check fails.

Definition at line 1178 of file stl_deque.h.

References std::deque< _Tp, _Alloc >::_M_range_check().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

const_reference std::deque< _Tp, _Alloc >::at | ( | size_type | __n | ) | const`[inline]`

Provides access to the data contained in the deque.

Parameters:

  | n | The index of the element for which data should be accessed.

Returns:
  Read-only (constant) reference to data.

Exceptions:

  | std::out_of_range | If n is an invalid index.

This function provides for safer data access. The parameter is first checked that it is in the range of the deque. The function throws out_of_range if the check fails.

Definition at line 1196 of file stl_deque.h.

References std::deque< _Tp, _Alloc >::_M_range_check().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

const_reference std::deque< _Tp, _Alloc >::back | ( |  | ) | const`[inline]`

Returns a read-only (constant) reference to the data at the last element of the deque.

Definition at line 1235 of file stl_deque.h.

References std::deque< _Tp, _Alloc >::end().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

reference std::deque< _Tp, _Alloc >::back | ( |  | ) | `[inline]`

Returns a read/write reference to the data at the last element of the deque.

Definition at line 1223 of file stl_deque.h.

References std::deque< _Tp, _Alloc >::end().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

iterator std::deque< _Tp, _Alloc >::begin | ( |  | ) | `[inline]`

Returns a read/write iterator that points to the first element in the deque. Iteration is done in ordinary element order.

Definition at line 976 of file stl_deque.h.

Referenced by std::deque< _Tp, _Alloc >::clear(), std::deque< _Tp, _Alloc >::deque(), std::deque< _Tp, _Alloc >::erase(), std::deque< _Tp, _Alloc >::front(), std::operator==(), and std::deque< _Tp, _Alloc >::~deque().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

const_iterator std::deque< _Tp, _Alloc >::begin | ( |  | ) | const`[inline]`

Returns a read-only (constant) iterator that points to the first element in the deque. Iteration is done in ordinary element order.

Definition at line 984 of file stl_deque.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

const_iterator std::deque< _Tp, _Alloc >::cbegin | ( |  | ) | const`[inline]`

Returns a read-only (constant) iterator that points to the first element in the deque. Iteration is done in ordinary element order.

Definition at line 1047 of file stl_deque.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

const_iterator std::deque< _Tp, _Alloc >::cend | ( |  | ) | const`[inline]`

Returns a read-only (constant) iterator that points one past the last element in the deque. Iteration is done in ordinary element order.

Definition at line 1056 of file stl_deque.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::deque< _Tp, _Alloc >::clear | ( |  | ) | `[inline]`

Erases all the elements. Note that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 1501 of file stl_deque.h.

References std::deque< _Tp, _Alloc >::begin().

Referenced by std::deque< _Tp, _Alloc >::_M_range_initialize(), std::deque< _Tp, _Alloc >::erase(), and std::deque< _Tp, _Alloc >::operator=().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

const_reverse_iterator std::deque< _Tp, _Alloc >::crbegin | ( |  | ) | const`[inline]`

Returns a read-only (constant) reverse iterator that points to the last element in the deque. Iteration is done in reverse element order.

Definition at line 1065 of file stl_deque.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

const_reverse_iterator std::deque< _Tp, _Alloc >::crend | ( |  | ) | const`[inline]`

Returns a read-only (constant) reverse iterator that points to one before the first element in the deque. Iteration is done in reverse element order.

Definition at line 1074 of file stl_deque.h.

template<typename _Tp , typename _Alloc >
template<typename... _Args>

deque< _Tp, _Alloc >::iterator deque::emplace | ( | iterator | __position,
|  | _Args &&... | __args |
| ) |  |  |

Inserts an object in deque before specified iterator.

Parameters:

  | position | An iterator into the deque.
  | args | Arguments.

Returns:
  An iterator that points to the inserted data.

This function will insert an object of type T constructed with T(std::forward<Args>(args)...) before the specified location.

Definition at line 144 of file deque.tcc.

References std::deque< _Tp, _Alloc >::push_back(), and std::deque< _Tp, _Alloc >::push_front().

Referenced by std::deque< _Tp, _Alloc >::insert().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

bool std::deque< _Tp, _Alloc >::empty | ( |  | ) | const`[inline]`

Returns true if the deque is empty. (Thus begin() would equal end().)

Definition at line 1122 of file stl_deque.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

iterator std::deque< _Tp, _Alloc >::end | ( |  | ) | `[inline]`

Returns a read/write iterator that points one past the last element in the deque. Iteration is done in ordinary element order.

Definition at line 993 of file stl_deque.h.

Referenced by std::deque< _Tp, _Alloc >::back(), std::deque< _Tp, _Alloc >::deque(), std::deque< _Tp, _Alloc >::erase(), std::operator==(), and std::deque< _Tp, _Alloc >::~deque().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

const_iterator std::deque< _Tp, _Alloc >::end | ( |  | ) | const`[inline]`

Returns a read-only (constant) iterator that points one past the last element in the deque. Iteration is done in ordinary element order.

Definition at line 1002 of file stl_deque.h.

template<typename _Tp , typename _Alloc >

deque< _Tp, _Alloc >::iterator deque::erase | ( | iterator | __position | ) |

Remove element at given position.

Parameters:

  | position | Iterator pointing to element to be erased.

Returns:
  An iterator pointing to the next element (or end()).

This function will erase the element at the given position and thus shorten the deque by one.

The user is cautioned that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 166 of file deque.tcc.

References std::deque< _Tp, _Alloc >::begin(), std::deque< _Tp, _Alloc >::end(), std::deque< _Tp, _Alloc >::pop_back(), std::deque< _Tp, _Alloc >::pop_front(), and std::deque< _Tp, _Alloc >::size().

template<typename _Tp , typename _Alloc >

deque< _Tp, _Alloc >::iterator deque::erase | ( | iterator | __first,
|  | iterator | __last |
| ) |  |  |

Remove a range of elements.

Parameters:

  | first | Iterator pointing to the first element to be erased.
  | last | Iterator pointing to one past the last element to be erased.

Returns:
  An iterator pointing to the element pointed to by last prior to erasing (or end()).

This function will erase the elements in the range [first,last) and shorten the deque accordingly.

The user is cautioned that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 189 of file deque.tcc.

References std::deque< _Tp, _Alloc >::begin(), std::deque< _Tp, _Alloc >::clear(), std::deque< _Tp, _Alloc >::end(), and std::deque< _Tp, _Alloc >::size().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

const_reference std::deque< _Tp, _Alloc >::front | ( |  | ) | const`[inline]`

Returns a read-only (constant) reference to the data at the first element of the deque.

Definition at line 1215 of file stl_deque.h.

References std::deque< _Tp, _Alloc >::begin().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

reference std::deque< _Tp, _Alloc >::front | ( |  | ) | `[inline]`

Returns a read/write reference to the data at the first element of the deque.

Definition at line 1207 of file stl_deque.h.

References std::deque< _Tp, _Alloc >::begin().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

allocator_type std::deque< _Tp, _Alloc >::get_allocator | ( |  | ) | const`[inline]`

Get a copy of the memory allocation object.

Reimplemented from std::_Deque_base< _Tp, _Alloc >.

Definition at line 967 of file stl_deque.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::deque< _Tp, _Alloc >::insert | ( | iterator | __position,
|  | size_type | __n,
|  | const value_type & | __x |
| ) |  |  | `[inline]`

Inserts a number of copies of given data into the deque.

Parameters:

  | position | An iterator into the deque.
  | n | Number of elements to be inserted.
  | x | Data to be inserted.

This function will insert a specified number of copies of the given data before the location specified by position.

Definition at line 1413 of file stl_deque.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::deque< _Tp, _Alloc >::insert | ( | iterator | __p,
|  | initializer_list< value_type > | __l |
| ) |  |  | `[inline]`

Inserts an initializer list into the deque.

Parameters:

  | p | An iterator into the deque.
  | l | An initializer_list.

This function will insert copies of the data in the initializer_list l into the deque before the location specified by p. This is known as list insert.

Definition at line 1399 of file stl_deque.h.

References std::deque< _Tp, _Alloc >::insert().

Referenced by std::deque< _Tp, _Alloc >::insert().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

iterator std::deque< _Tp, _Alloc >::insert | ( | iterator | __position,
|  | value_type && | __x |
| ) |  |  | `[inline]`

Inserts given rvalue into deque before specified iterator.

Parameters:

  | position | An iterator into the deque.
  | x | Data to be inserted.

Returns:
  An iterator that points to the inserted data.

This function will insert a copy of the given rvalue before the specified location.

Definition at line 1386 of file stl_deque.h.

References std::deque< _Tp, _Alloc >::emplace().

template<typename _Tp , typename _Alloc >

deque< _Tp, _Alloc >::iterator deque::insert | ( | iterator | __position,
|  | const value_type & | __x |
| ) |  |  |

Inserts given value into deque before specified iterator.

Parameters:

  | position | An iterator into the deque.
  | x | Data to be inserted.

Returns:
  An iterator that points to the inserted data.

This function will insert a copy of the given value before the specified location.

Definition at line 121 of file deque.tcc.

References std::deque< _Tp, _Alloc >::push_back(), and std::deque< _Tp, _Alloc >::push_front().

Referenced by std::deque< _Tp, _Alloc >::resize().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>
template<typename _InputIterator >

void std::deque< _Tp, _Alloc >::insert | ( | iterator | __position,
|  | _InputIterator | __first,
|  | _InputIterator | __last |
| ) |  |  | `[inline]`

Inserts a range into the deque.

Parameters:

  | position | An iterator into the deque.
  | first | An input iterator.
  | last | An input iterator.

This function will insert copies of the data in the range [first,last) into the deque before the location specified by pos. This is known as range insert.

Definition at line 1428 of file stl_deque.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

size_type std::deque< _Tp, _Alloc >::max_size | ( |  | ) | const`[inline]`

Returns the size() of the largest possible deque.

Definition at line 1086 of file stl_deque.h.

Referenced by std::deque< _Tp, _Alloc >::_M_new_elements_at_back(), and std::deque< _Tp, _Alloc >::_M_new_elements_at_front().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

deque& std::deque< _Tp, _Alloc >::operator= | ( | initializer_list< value_type > | __l | ) | `[inline]`

Assigns an initializer list to a deque.

Parameters:

  | l | An initializer_list.

This function fills a deque with copies of the elements in the initializer_list l.

Note that the assignment completely changes the deque and that the resulting deque's size is the same as the number of elements assigned. Old data may be lost.

Definition at line 907 of file stl_deque.h.

References std::deque< _Tp, _Alloc >::assign().

template<typename _Tp , typename _Alloc >

deque< _Tp, _Alloc > & deque::operator= | ( | const deque< _Tp, _Alloc > & | __x | ) |

Deque assignment operator.

Parameters:

  | x | A deque of identical element and allocator types.

All the elements of x are copied, but unlike the copy constructor, the allocator object is not copied.

Definition at line 65 of file deque.tcc.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

deque& std::deque< _Tp, _Alloc >::operator= | ( | deque< _Tp, _Alloc > && | __x | ) | `[inline]`

Deque move assignment operator.

Parameters:

  | x | A deque of identical element and allocator types.

The contents of x are moved into this deque (without copying). x is a valid, but unspecified deque.

Definition at line 886 of file stl_deque.h.

References std::deque< _Tp, _Alloc >::clear(), and std::deque< _Tp, _Alloc >::swap().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

const_reference std::deque< _Tp, _Alloc >::operator[] | ( | size_type | __n | ) | const`[inline]`

Subscript access to the data contained in the deque.

Parameters:

  | n | The index of the element for which data should be accessed.

Returns:
  Read-only (constant) reference to data.

This operator allows for easy, array-style, data access. Note that data access with this operator is unchecked and out_of_range lookups are not defined. (For checked lookups see at().)

Definition at line 1153 of file stl_deque.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

reference std::deque< _Tp, _Alloc >::operator[] | ( | size_type | __n | ) | `[inline]`

Subscript access to the data contained in the deque.

Parameters:

  | n | The index of the element for which data should be accessed.

Returns:
  Read/write reference to data.

This operator allows for easy, array-style, data access. Note that data access with this operator is unchecked and out_of_range lookups are not defined. (For checked lookups see at().)

Definition at line 1138 of file stl_deque.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::deque< _Tp, _Alloc >::pop_back | ( |  | ) | `[inline]`

Removes last element.

This is a typical stack operation. It shrinks the deque by one.

Note that no data is returned, and if the last element's data is needed, it should be retrieved before pop_back() is called.

Definition at line 1336 of file stl_deque.h.

References std::deque< _Tp, _Alloc >::_M_pop_back_aux().

Referenced by std::deque< _Tp, _Alloc >::erase().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::deque< _Tp, _Alloc >::pop_front | ( |  | ) | `[inline]`

Removes first element.

This is a typical stack operation. It shrinks the deque by one.

Note that no data is returned, and if the first element's data is needed, it should be retrieved before pop_front() is called.

Definition at line 1315 of file stl_deque.h.

References std::deque< _Tp, _Alloc >::_M_pop_front_aux().

Referenced by std::deque< _Tp, _Alloc >::erase().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::deque< _Tp, _Alloc >::push_back | ( | const value_type & | __x | ) | `[inline]`

Add data to the end of the deque.

Parameters:

  | x | Data to be added.

This is a typical stack operation. The function creates an element at the end of the deque and assigns the given data to it. Due to the nature of a deque this operation can be done in constant time.

Definition at line 1284 of file stl_deque.h.

References std::deque< _Tp, _Alloc >::_M_push_back_aux().

Referenced by std::deque< _Tp, _Alloc >::_M_range_initialize(), std::deque< _Tp, _Alloc >::emplace(), and std::deque< _Tp, _Alloc >::insert().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::deque< _Tp, _Alloc >::push_front | ( | const value_type & | __x | ) | `[inline]`

Add data to the front of the deque.

Parameters:

  | x | Data to be added.

This is a typical stack operation. The function creates an element at the front of the deque and assigns the given data to it. Due to the nature of a deque this operation can be done in constant time.

Definition at line 1253 of file stl_deque.h.

References std::deque< _Tp, _Alloc >::_M_push_front_aux().

Referenced by std::deque< _Tp, _Alloc >::emplace(), and std::deque< _Tp, _Alloc >::insert().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

const_reverse_iterator std::deque< _Tp, _Alloc >::rbegin | ( |  | ) | const`[inline]`

Returns a read-only (constant) reverse iterator that points to the last element in the deque. Iteration is done in reverse element order.

Definition at line 1020 of file stl_deque.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

reverse_iterator std::deque< _Tp, _Alloc >::rbegin | ( |  | ) | `[inline]`

Returns a read/write reverse iterator that points to the last element in the deque. Iteration is done in reverse element order.

Definition at line 1011 of file stl_deque.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

const_reverse_iterator std::deque< _Tp, _Alloc >::rend | ( |  | ) | const`[inline]`

Returns a read-only (constant) reverse iterator that points to one before the first element in the deque. Iteration is done in reverse element order.

Definition at line 1038 of file stl_deque.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

reverse_iterator std::deque< _Tp, _Alloc >::rend | ( |  | ) | `[inline]`

Returns a read/write reverse iterator that points to one before the first element in the deque. Iteration is done in reverse element order.

Definition at line 1029 of file stl_deque.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::deque< _Tp, _Alloc >::resize | ( | size_type | __new_size,
|  | value_type | __x = `value_type()` |
| ) |  |  | `[inline]`

Resizes the deque to the specified number of elements.

Parameters:

  | new_size | Number of elements the deque should contain.
  | x | Data with which new elements should be populated.

This function will resize the deque to the specified number of elements. If the number is smaller than the deque's current size the deque is truncated, otherwise the deque is extended and new elements are populated with given data.

Definition at line 1101 of file stl_deque.h.

References std::deque< _Tp, _Alloc >::insert(), and std::deque< _Tp, _Alloc >::size().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::deque< _Tp, _Alloc >::shrink_to_fit | ( |  | ) | `[inline]`

A non-binding request to reduce memory use.

Definition at line 1113 of file stl_deque.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

size_type std::deque< _Tp, _Alloc >::size | ( |  | ) | const`[inline]`

Returns the number of elements in the deque.

Definition at line 1081 of file stl_deque.h.

Referenced by std::deque< _Tp, _Alloc >::_M_new_elements_at_back(), std::deque< _Tp, _Alloc >::_M_new_elements_at_front(), std::deque< _Tp, _Alloc >::_M_range_check(), std::deque< _Tp, _Alloc >::erase(), std::operator==(), and std::deque< _Tp, _Alloc >::resize().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::deque< _Tp, _Alloc >::swap | ( | deque< _Tp, _Alloc > & | __x | ) | `[inline]`

Swaps data with another deque.

Parameters:

  | x | A deque of the same element and allocator types.

This exchanges the elements between two deques in constant time. (Four pointers, so it should be quite fast.) Note that the global std::swap() function is specialized such that std::swap(d1,d2) will feed to this function.

Definition at line 1481 of file stl_deque.h.

Referenced by std::deque< _Tp, _Alloc >::operator=(), and std::swap().

The documentation for this class was generated from the following files:

- stl_deque.h
- deque.tcc